#import "BuzzBoosterPlugin.h"
#import "FLCampaignFloatingActionButtonFactory+View.h"
#import "FLCampaignEntryViewFactory+View.h"

@implementation BuzzBoosterPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"buzz_booster"
            binaryMessenger:[registrar messenger]];
  BuzzBoosterPlugin* instance = [[BuzzBoosterPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];

  FLCampaignFloatingActionButtonFactory* campaignFloatingActionButtonFactory =
      [[FLCampaignFloatingActionButtonFactory alloc] initWithMessenger:registrar.messenger];
  [registrar registerViewFactory:campaignFloatingActionButtonFactory withId:@"CampaignFloatingActionButton"];
  FLCampaignEntryViewFactory* campaignEntryViewFactory =
      [[FLCampaignEntryViewFactory alloc] initWithMessenger:registrar.messenger];
  [registrar registerViewFactory:campaignEntryViewFactory withId:@"CampaignEntryView"];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"init" isEqualToString:call.method]) {
    NSString *appKey = call.arguments[@"appKey"];
    BSTConfig *config = [BSTConfig configWithBlock:^(BSTConfigBuilder * _Nonnull builder) {
      builder.appKey = appKey;
    }];
    [BuzzBooster initializeWithConfig:config];
    result(nil);
  } else if ([@"setUserId" isEqualToString:call.method]) {
    NSString *userId = call.arguments[@"userId"];
    [BuzzBooster setUserId:userId];
    
    result(nil);
  } else {
    result(FlutterMethodNotImplemented);
  }
}

@end
